<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>UnionCombiner (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="UnionCombiner (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/UnionCombiner.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/TreeUtils.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/UnionCombiner.html" target="_top">Frames</a></li>
<li><a href="UnionCombiner.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields.inherited.from.class.org.apache.commons.configuration2.tree.NodeCombiner">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.tree</div>
<h2 title="Class UnionCombiner" class="title">Class UnionCombiner</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li><a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html" title="class in org.apache.commons.configuration2.tree">org.apache.commons.configuration2.tree.NodeCombiner</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.tree.UnionCombiner</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">UnionCombiner</span>
extends <a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html" title="class in org.apache.commons.configuration2.tree">NodeCombiner</a></pre>
<div class="block"><p>
 A specialized implementation of the <code>NodeCombiner</code> interface
 that constructs a union from two passed in node hierarchies.
 </p>
 <p>
 The given source hierarchies are traversed, and their nodes are added to the
 resulting structure. Under some circumstances two nodes can be combined
 rather than adding both. This is the case if both nodes are single children
 (no lists) of their parents and do not have values. The corresponding check
 is implemented in the <code>findCombineNode()</code> method.
 </p>
 <p>
 Sometimes it is not possible for this combiner to detect whether two nodes
 can be combined or not. Consider the following two node hierarchies:
 </p>

 <pre>
 Hierarchy 1:

 Database
   +--Tables
        +--Table
             +--name [users]
             +--fields
                   +--field
                   |    +--name [uid]
                   +--field
                   |    +--name [usrname]
                     ...
 </pre>

 <pre>
 Hierarchy 2:

 Database
   +--Tables
        +--Table
             +--name [documents]
             +--fields
                   +--field
                   |    +--name [docid]
                   +--field
                   |    +--name [docname]
                     ...
 </pre>

 <p>
 Both hierarchies contain data about database tables. Each describes a single
 table. If these hierarchies are to be combined, the result should probably
 look like the following:
 </p>

 <pre>
 Database
   +--Tables
        +--Table
        |    +--name [users]
        |    +--fields
        |          +--field
        |          |    +--name [uid]
        |            ...
        +--Table
             +--name [documents]
             +--fields
                   +--field
                   |    +--name [docid]
                     ...
 </pre>

 <p>
 i.e. the <code>Tables</code> nodes should be combined, while the
 <code>Table</code> nodes should both be added to the resulting tree. From
 the combiner's point of view there is no difference between the
 <code>Tables</code> and the <code>Table</code> nodes in the source trees,
 so the developer has to help out and give a hint that the <code>Table</code>
 nodes belong to a list structure. This can be done using the
 <code>addListNode()</code> method; this method expects the name of a node,
 which should be treated as a list node. So if
 <code>addListNode("Table");</code> was called, the combiner knows that it
 must not combine the <code>Table</code> nodes, but add it both to the
 resulting tree.
 </p>
 <p>
 Another limitation is the handling of attributes: Attributes can only
 have a single value. So if two nodes are to be combined which both have
 an attribute with the same name, it is not possible to construct a
 proper union attribute. In this case, the attribute value from the
 first node is used.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.3</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: UnionCombiner.java 1790899 2017-04-10 21:56:46Z ggregory $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="fields.inherited.from.class.org.apache.commons.configuration2.tree.NodeCombiner">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;org.apache.commons.configuration2.tree.<a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html" title="class in org.apache.commons.configuration2.tree">NodeCombiner</a></h3>
<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html#HANDLER">HANDLER</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/UnionCombiner.html#UnionCombiner--">UnionCombiner</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/UnionCombiner.html#combine-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-">combine</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node1,
       <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node2)</code>
<div class="block">Combines the given nodes to a new union node.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/UnionCombiner.html#findCombineNode-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-">findCombineNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node1,
               <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node2,
               <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;child)</code>
<div class="block">
 Tries to find a child node of the second source node, with which a child
 of the first source node can be combined.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.apache.commons.configuration2.tree.NodeCombiner">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.apache.commons.configuration2.tree.<a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html" title="class in org.apache.commons.configuration2.tree">NodeCombiner</a></h3>
<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html#addListNode-java.lang.String-">addListNode</a>, <a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html#getListNodes--">getListNodes</a>, <a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html#isListNode-org.apache.commons.configuration2.tree.ImmutableNode-">isListNode</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="UnionCombiner--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>UnionCombiner</h4>
<pre>public&nbsp;UnionCombiner()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="combine-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>combine</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;combine(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node1,
                             <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node2)</pre>
<div class="block">Combines the given nodes to a new union node.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html#combine-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-">combine</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/NodeCombiner.html" title="class in org.apache.commons.configuration2.tree">NodeCombiner</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node1</code> - the first source node</dd>
<dd><code>node2</code> - the second source node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the union node</dd>
</dl>
</li>
</ul>
<a name="findCombineNode-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-org.apache.commons.configuration2.tree.ImmutableNode-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>findCombineNode</h4>
<pre>protected&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;findCombineNode(<a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node1,
                                        <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;node2,
                                        <a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree">ImmutableNode</a>&nbsp;child)</pre>
<div class="block"><p>
 Tries to find a child node of the second source node, with which a child
 of the first source node can be combined. During combining of the source
 nodes an iteration over the first source node's children is performed.
 For each child node it is checked whether a corresponding child node in
 the second source node exists. If this is the case, these corresponding
 child nodes are recursively combined and the result is added to the
 combined node. This method implements the checks whether such a recursive
 combination is possible. The actual implementation tests the following
 conditions:
 </p>
 <ul>
 <li>In both the first and the second source node there is only one child
 node with the given name (no list structures).</li>
 <li>The given name is not in the list of known list nodes, i.e. it was
 not passed to the <code>addListNode()</code> method.</li>
 <li>None of these matching child nodes has a value.</li>
 </ul>
 <p>
 If all of these tests are successful, the matching child node of the
 second source node is returned. Otherwise the result is <b>null</b>.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node1</code> - the first source node</dd>
<dd><code>node2</code> - the second source node</dd>
<dd><code>child</code> - the child node of the first source node to be checked</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the matching child node of the second source node or <b>null</b>
 if there is none</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/UnionCombiner.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/TreeUtils.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/UnionCombiner.html" target="_top">Frames</a></li>
<li><a href="UnionCombiner.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#fields.inherited.from.class.org.apache.commons.configuration2.tree.NodeCombiner">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
